<template>
    <main id="js-page-content" role="main" class="page-content">
        <ol class="breadcrumb page-breadcrumb">
            <li class="breadcrumb-item"><a href="javascript:void(0);">SmartAdmin</a></li>
            <li class="breadcrumb-item"><router-link to="/index">Dashboard</router-link></li>
            <li class="breadcrumb-item"><router-link to="/surveys">Surveys</router-link></li>
            <li class="breadcrumb-item active">{{ survey.survey.title }}</li>
        </ol>
        <div class="row">
            <div class="col-xl-6">
                <div id="panel-1" class="panel">
                    <div class="panel-hdr">
                        <h2>
                            {{ survey.survey.title }}
                        </h2>

                        <div v-if="checkAuthor">
                            <button v-if="survey.status == 'workInProgress'" class="btn btn-primary btn-sm" style="margin: 5px;" @click="editSurvey(survey._id)">
                                <i class="fa fa-edit"></i> Edit
                            </button>

                            <button class="btn btn-danger btn-sm" @click="deleteSurvey">
                                <i class="fa fa-trash"></i> Delete
                            </button>
                        </div>

                        <button v-if="checkIfAdmin" class="btn btn-success btn-sm" style="margin: 5px;" @click="approveSurvey">
                            <i class="fa fa-check"></i> Approve
                        </button>
                    </div>

                    <div class="panel-container show">
                        <div class="panel-content">
                            <div class="panel-tag">
                                <code>Status: </code> <span class="badge" :class="surveyStatus.class" style="font-size: 12px; padding: 10px;">{{ surveyStatus.text }}</span> <br/><br/>
                                <code>Author: </code> {{ survey.user }} <br/><br/>
                                <code>Description: </code>{{ survey.survey.description || '-' }}
                            </div>

                            <div class="demo-v-spacing">
                                <survey :survey="surveyModel"></survey>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
</template>

<script>
    import axios from 'axios';
    import Swal from 'sweetalert2'
    import * as SurveyVue from 'survey-vue';

    export default {
        name: 'SurveyDetail',
        data() {
            return {
                survey: {
                    user: '',
                    survey: {
                        title: '',
                        description: ''
                    },
                    status: ''
                },
                surveyModel: ''
            }
        },

        async created() {
            let survey = await axios.get(`http://ec2-54-89-84-11.compute-1.amazonaws.com:3000/api/surveyDetails/${this.$route.params.id}`,
                {
                    headers: {
                        'Authorization': `Bearer ${localStorage.getItem('accessToken')}`
                    }
                });

            this.survey = survey.data.data;
            this.surveyModel = new SurveyVue.Model(survey.data.data.survey);
        },

        computed: {
            surveyStatus() {
                switch (this.survey.status) {
                    case "waitingForApproval": return { class: 'badge-warning', text: 'Waiting for Approval'};
                    case "approved": return { class: 'badge-success', text: 'Approved'};
                    default: return { class: 'badge-success', text: 'Work in Progress' };
                }
            },

            checkAuthor() {
                const currentUser = localStorage.getItem('username');
                if (this.survey.user == currentUser) {
                    return true;
                }
                return false;
            },

            checkIfAdmin() {
                const currentUserRole = localStorage.getItem('role');
                if(currentUserRole == 'admin' && this.survey.status == 'waitingForApproval') {
                    return true;
                }
                return false;
            }
        },

        methods: {
            async deleteSurvey() {
                Swal.fire({
                    title: 'Are you sure?',
                    text: "You won't be able to revert this!",
                    icon: 'warning',
                    showCancelButton: true,
                    confirmButtonColor: '#3085d6',
                    cancelButtonColor: '#d33',
                    confirmButtonText: 'Yes, delete it!'
                }).then(async (result) => {

                    if (result.value) {
                        await axios.delete(`http://ec2-54-89-84-11.compute-1.amazonaws.com:3000/api/deleteSurvey/${this.$route.params.id}`,
                            {
                                headers: {
                                    'Authorization': `Bearer ${localStorage.getItem('accessToken')}`
                                }
                            })
                            .then(() => {
                                Swal.fire(
                                    'Deleted!',
                                    'Your survey has been deleted.',
                                    'success'
                                )

                            })
                            .catch(()=>{
                                Swal.fire({
                                    icon: 'error',
                                    title: 'Oops...',
                                    text: 'Something went wrong!',
                                    showConfirmButton: false,
                                    timer: 1500
                                });
                            });

                        this.$router.push(`/surveys`);
                    }
                })
            },

            editSurvey(id) {
                this.$router.push(`/survey/edit/${id}`)
            },

            approveSurvey() {
                Swal.fire({
                    title: 'Are you sure?',
                    text: "You won't be able to revert this!",
                    icon: 'warning',
                    showCancelButton: true,
                    confirmButtonColor: '#3085d6',
                    cancelButtonColor: '#d33',
                    confirmButtonText: 'Yes, approve it!'
                }).then(async (result) => {

                    if (result.value) {
                        await axios.put(`http://ec2-54-89-84-11.compute-1.amazonaws.com:3000/api/approveSurvey/${this.$route.params.id}`, {},
                            {
                                headers: {
                                    'Authorization': `Bearer ${localStorage.getItem('accessToken')}`
                                }
                            })
                            .then(() => {
                                Swal.fire(
                                    'Approved!',
                                    'The survey has been published.',
                                    'success'
                                )

                            })
                            .catch(()=>{
                                Swal.fire({
                                    icon: 'error',
                                    title: 'Oops...',
                                    text: 'Something went wrong!',
                                    showConfirmButton: false,
                                    timer: 1500
                                });
                            });

                        this.$router.push(`/surveys`);
                    }
                })
            }
        }
    }
</script>

<style scoped>

</style>
